#include <fstream>
#include <iostream>
#include "enumerator.h"

using namespace std;

istream& operator>>(istream &be, EnorData &data)
{
    be >> data.azonosito >> data.osszeg;
    return be;
}

ostream& operator<<(ostream &ki, const EnorData &data)
{
    ki << data.azonosito << ": " << data.osszeg << " Ft" << endl;
    return ki;
}

Enumerator::Enumerator(string torzsNev, string modositoNev)
{
    torzs.open(torzsNev.c_str());
    modosito.open(modositoNev.c_str());

    if(torzs.fail() || modosito.fail())
        throw HibasFajl;
}

void Enumerator::First()
{
    modosito >> tranzakcio;
    Next();
}

void Enumerator::Next()
{
    torzs >> egyenleg;
    if(torzs.eof() || (!modosito.eof() && egyenleg.azonosito > tranzakcio.azonosito))
    {
        while(egyenleg.azonosito > tranzakcio.azonosito && !modosito.eof())
            modosito >> tranzakcio;
    }

    if(modosito.eof() || (!torzs.eof() && egyenleg.azonosito < tranzakcio.azonosito))
    {
        return;
    }

    if(!torzs.eof() && !modosito.eof() && egyenleg.azonosito == tranzakcio.azonosito)
    {
        while(egyenleg.azonosito == tranzakcio.azonosito && !modosito.eof())
        {
            egyenleg.osszeg += tranzakcio.osszeg;
            modosito >> tranzakcio;
        }
    }
}

EnorData Enumerator::Current() const
{
    return egyenleg;
}

bool Enumerator::End() const
{
    return torzs.eof();
}

